	subroutine rs(nxe,x,nye,y,midn)
c/-------------------------------------------------------------------\
c|  nxe.ge.nx and nye.ge.nx (in our program nxe=nye=nx=1440)         | 
c|   x(nx,1),x(nx,2) - horizontal components (nx - length of series) |
c|   y(nx,1),y(nx,2) - regular part of horizontal components         |
c|   midn - midnight in UT time.                                     |
c\-------------------------------------------------------------------/   
	parameter (nx=24*60,ke=3)
	real y(nye,2),x(nxe,2)
	real*8 a(nx,ke),b(nx,ke),yy(nx),del
	real del1(nx)
	del=4.e-7
	dela=4.e-7
	anoc=0.08
	mno=1
	ipol=midn
	call ini (k,nx,nx,a)
	call bchol (del,k,nx,nx,a)
	do 50 i=1,2
		call bsol (del,k,nx,nx,a,x(1,i),yy)
		do 74 j=1,nx
74              y(j,i)=yy(j)
		do 73 j=1,nx
73              y(j,i)=x(j,i)-y(j,i)
		call wg (nx,y(1,i),dela,del1,mno,ipol,anoc)
		call ini (k,nx,nx,b)
		call bchol1 (del1,k,nx,nx,b)
		call bsol1 (del1,k,nx,nx,b,x(1,i),yy)
		do 35 j=1,nx
35              y(j,i)=sngl(yy(j))
50      continue
	end
	subroutine wg (n,dx,del,y,mno,ipol,anoc)
	real y(n),dx(n)
	del1=.001*del
	do 10 j=1,n
10      y(j)=del
	do 40 i=1,n,60
		p=ext(60,dx(i))
c               q=del/exp((p-6.66)/6.66)
			do 20 j=i,i+59
			pp=(p-6.66)/6.66
			if(pp.gt.50.)pp=50.
		vav=exp(pp)
				y(j)=del/vav
20                      continue 
40      continue
	do 30 i=1,n
	ipol=1440-ipol*60
	j=i+ipol
	if(j.lt.0)j=1440+j
	if(j.gt.1440)j=j-1440
	    if(j.le.240.or.j.ge.1200)then
	      y(i)=y(i)*anoc
	else
	   if(j.ge.480.and.j.le.960)then
	   y(i)=y(i)*(1.+anoc)
	   else
	   y(i)=y(i)*(((iabs(480-iabs(j-720)))/240.)+anoc)      
	   end if
	end if  
30      continue
	do 81 i=1,n
81      y(i)=y(i)*mno
90      return
	end
	function ext (n,x)
	real x(n)
	xi=x(1)
	xa=xi
	do 10 i=2,n
		if (x(i).lt.xi) xi=x(i)
		if (x(i).gt.xa) xa=x(i)
10      continue
	ext=xa-xi
c       write (*,'(1x,3f10.2)') xi,xa,ext
	return
	end
	subroutine bchol (del,k,n,nm,a)
	real*8 a(nm,k),del,filsk
	do 20 i=1,n
		if=max0(1,k-i+1)
		a(i,k)=dsqrt(a(i,k)+del-filsk(k-if,a(i,if),nm,a(i,if),nm))
		do 10 j=i+1,min0(n,i+k-1)
			jf=max0(1,k+1-j)
			il=k-j+i
			a(j,il)=
     x (a(j,il)-filsk(il-jf,a(i,j-i+jf),nm,a(j,jf),nm))/a(i,k)
10              continue
20      continue
	return
	end
	subroutine bsol (del,k,n,nm,a,b,x)
	real*8 a(nm,k),x(n),del,filsk
	real b(n)
	do 10 i=1,n
		il=min0(i,k)-1
		x(i)=(b(i)*del-filsk(il,a(i,k-il),nm,x(i-il),1))/a(i,k)
10      continue
	do 20 i=n,1,-1
		il=min0(n-i+1,k)-1
		x(i)=(x(i)-filsk(il,a(i+1,k-1),-nm+1,x(i+1),1))/a(i,k)
20      continue
	return
	end
	subroutine bchol1 (del,k,n,nm,a)
	real*8 a(nm,k),del(n)*4,filsk
	do 20 i=1,n
		if=max0(1,k-i+1)
		a(i,k)=dsqrt(a(i,k)+del(i)-filsk(k-if,a(i,if),nm,a(i,if),nm))
		do 10 j=i+1,min0(n,i+k-1)
			jf=max0(1,k+1-j)
			il=k-j+i
			a(j,il)=
     x (a(j,il)-filsk(il-jf,a(i,j-i+jf),nm,a(j,jf),nm))/a(i,k)
10              continue
20      continue
	return
	end
	subroutine bsol1 (del,k,n,nm,a,b,x)
	real*8 a(nm,k),x(n),del(n)*4,filsk
	real b(n)
	do 10 i=1,n
		il=min0(i,k)-1
		x(i)=(b(i)*del(i)-filsk(il,a(i,k-il),nm,x(i-il),1))/a(i,k)
10      continue
	do 20 i=n,1,-1
		il=min0(n-i+1,k)-1
		x(i)=(x(i)-filsk(il,a(i+1,k-1),-nm+1,x(i+1),1))/a(i,k)
20      continue
	return
	end
	real*8 function filsk (n,x,nx,y,ny)
	real*8 x(*),y(*)
	filsk=0.
	ix=1
	iy=1
	do 10 i=1,n
		filsk=filsk+x(ix)*y(iy)
		ix=ix+nx
		iy=iy+ny
10      continue
	return
	end
	subroutine ini (k,n,nm,a)
	real*8 a(nm,*)
	k=3
c
	a(1,1)=0.
	a(2,1)=0.
	do 10 i=1,n-2
10      a(i+2,1)=1.
c
	a(1,2)=0.
	a(2,2)=-2.
	do 20 i=1,n-3
20      a(i+2,2)=-4.
	a(n,2)=-2.
c
	a(1,3)=1.
	a(2,3)=5.
	do 30 i=1,n-4
30      a(i+2,3)=6.
	a(n-1,3)=5.
	a(n,3)=1.
c
	return
	end
